#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <dos.h>

extern void Init();
extern void MutareaMea(long nr);
extern void MutareaTa(long &nr);

const
  MaxN = 1001;

FILE *f_;
int Nr_Diferite,i,n;
long nr;

long a[MaxN];
int c[MaxN];
void inv(void)
{
 int i;
 long sc;
 for (i = 1; i <= Nr_Diferite / 2; i++){
   sc = a[i];
   a[i] = a[Nr_Diferite+1-i];
   a[Nr_Diferite+1-i] = sc;
 }
}
//------------------------------------------------------------------------------
int Final(void)
{
  return (Nr_Diferite == 0);
};
//------------------------------------------------------------------------------
int Sigur(void)
{
  if (Nr_Diferite == 0)
    return 0;
  else if (a[Nr_Diferite] == 1)
         return c[Nr_Diferite];
       else
         return 1;
}
//------------------------------------------------------------------------------
void ExecutaMutare(long nr)
{
  a[Nr_Diferite] = a[Nr_Diferite] - nr;
  if (a[Nr_Diferite] == 0)
    Nr_Diferite--;
}
//------------------------------------------------------------------------------
int CalculeazaDiferente(void)
{
  int i,k;
  unsigned long c1,c2,s;

  k = 1; s = 1;
  c1 = a[1];
  for (i = 2; i<= n; i++)
    if (a[i]-a[s] != 0){
      c2 = a[i] - a[s];
      a[k] = c1;
      c1 = c2;
      k++;
      s = i;
    };
  if (c1 != 0)
    a[k] = c1;
  return k;
};
//------------------------------------------------------------------------------
void CalculeazaStrategie(void)
{
  c[1] = 1;
  for (int i = 2; i <= Nr_Diferite; i++)
	if (a[i-1] > 1)
	  c[i] = 0;
	else c[i] = !c[i-1];
};
//------------------------------------------------------------------------------
void qw(int l, int r)
{
  int i,j;
  long x,y;
  i = l;
  j = r;
  x = a[(l+r)/2];
  do{
	while (a[i] < x) i++;
	while (x < a[j]) j--;
	if (i <= j){
	  y = a[i]; a[i] = a[j]; a[j] = y;
	  i++; j--;
	}
  }while (i <= j);
  if (l < j) qw(l,j);
  if (i < r) qw(i,r);
}

void main(void)
{
  Init();
  f_=fopen("joc.in","r");
  fscanf(f_,"%d",&n);
  for (i=1; i<=n; i++)
    fscanf(f_,"%ld",&a[i]);
  fclose(f_);
  qw(1,n);
  Nr_Diferite = CalculeazaDiferente();
  inv();
  CalculeazaStrategie();

  while (!Final()){
    //mutarea mea
    if (c[Nr_Diferite]){
      MutareaMea(a[Nr_Diferite]);
      ExecutaMutare(a[Nr_Diferite]);
    }
    else{
       MutareaMea(a[Nr_Diferite]-1);
       ExecutaMutare(a[Nr_Diferite]-1);
    }
    //mutarea calculatorului
    MutareaTa(nr);
    ExecutaMutare(nr);
  };
}