Program Minimizare_Automat;
const   Intrare = 'Automat.in';
        Iesire = 'Automat.out';

type    MultimeStari = Set of Byte;
        Factorizare = array[Byte] of MultimeStari;

var
    i, j, K, l, m, nr_clase, KNou, stanga, t : byte;
    a, b, a1, b1, final, final1 : array[Byte] of Byte;
    gasit, test1, test2 : Boolean;
    clasa, noua_clasa :Factorizare;

procedure Citire;
var fin: text;
    i: Byte;
Begin
     assign(fin, intrare); reset(fin);
     ReadLn(fin, K);
     For i := 1 to K do
         ReadLn(fin,a[i], b[i], final[i]);
     close (fin);
End;

procedure Afisare;
var  fout: Text;
     i: Byte;
Begin
     assign(fout, iesire); rewrite(fout);
     WriteLn(fout, KNou);
     For i:= 1 to KNou do
         WriteLn(fout, a1[i],' ',b1[i],' ',final1[i]);
     close(fout);
End;

Begin
Citire;
{construiesc doua clase de stari: stari finale si stari nefinale}
For i := 1 to K do
    if final[i]=0 then clasa[1] := clasa[1] + [i]
                  else clasa[2] := clasa[2] + [i];
KNou := 2;

Repeat
  nr_clase := KNou; KNou := 0;
  For i := 1 to nr_clase do
      begin
      {rafinez clasa i}
      stanga := KNou; {aici se termina rafinarea clasei i-1}
      For j := 1 to K do
          begin
          if j in clasa[i] then
             begin {starea j este din clasa[i]}

             gasit := false;
             l := stanga;
            {caut o clasa din cele nou construite in care sa-l pot plasa pe j}
            {starile j t pot face parte din aceeasi clasa daca si numai daca
             prin intermediul literelor a si b se trece in stari din aceeasi clasa}

             while not gasit and (l < KNou) do
                   begin
                   l := l+1;
                   {caut un element t din noua_clasa[l]}

                   t := 1;
                   while not (t in noua_clasa[l]) do inc(t);

                   m := 0; test1 := false; test2 := false;
                   {verific daca exista o clasa m astfel incat citind litera a
                   atat t, reprezentantul noii clase l cat si j sa "treaca"
                   intr-un element din clasa m}

                   while (not(test1) and (m < nr_clase)) do
                         begin
                         m := m+1;
                         test1 := (a[t] in clasa[m]) and (a[j] in clasa[m]);
                         end;{while}

                   if  test1 then
                       begin

                       {atat j cat si t sunt trecuti prin litera a in stari din aceeasi clasa}
                       m := 0;
                       {verific daca exista o clasa m astfel incat citind litera b
                   atat t, reprezentantul noii clase l cat si j sa "treaca"
                   intr-un element din clasa m}
                       while (not(test2) and (m < nr_clase)) do
                             begin
                             m := m+1;
                             test2 := (b[t] in clasa[m]) and (b[j] in clasa[m]);
                             end;{while}
                       end; {if}

                   if test2 then  {j si t fac parte din acceasi clasa l}
                      begin
                      gasit := true;
                      noua_clasa[l] := noua_clasa[l] + [j];
                      end; {if}
                   end; {while}

             if not gasit then
                begin
                {j constituie separat o noua clasa}
                KNou := KNou + 1;
                noua_clasa[KNou] := [j];
                end;{if}
             end; {if}
          end;{for}
      end; {for}
  For i := 1 to KNou do clasa[i] := noua_clasa[i];
until KNou = nr_clase;

{*** Construiesc noul automat ***}
For i := 1 to KNou do
    begin
    {caut un reprezentant j al clasei i}
    j:= 1;
    while not (j in clasa[i]) do inc(j);

    final1[i] := final[j];

    l := a[j]; t:= b[j];

    {caut clasa j din care face parte l}
    j := 1;
    While not (l in clasa[j]) do inc(j);
    a1[i] := j;

    {caut clasa j din care face parte t}
    j := 1;
    While not(t in clasa[j]) do inc(j);
    b1[i] := j;
    end; {for}
Afisare;
End.

