program excursia;

const ni='excursia.in';
      no='excursia.out';
      nmax=100;
      mmax=100;
      kmax=10;

type sirlong=array [1..mmax] of longint;
     psirlong=^sirlong;
     matlong=array [1..nmax] of psirlong;
     vector=array [1..nmax*mmax] of longint;
     pvector=^vector;
     sirword=array [1..mmax] of word;
     psirword=^sirword;
     matword=array [1..nmax] of psirword;

var f:text;
    a:matlong;
    b,c:pvector;
    s,nr:array [1..nmax*mmax] of word;
    dif,cate:array [1..mmax,1..kmax] of word;
    l,over:array [1..mmax] of word;
    n,m,k,i,j,med,lini,coli,linj,colj,linmed,colmed,aux,prev,crt,max,v,h,
    lmic,cmic,lmare,cmare,p,u,total,stop,add,pz,temp:longint;

procedure load;
begin
     assign(f,ni);reset(f);
     readln(f,n,m,k);
     for i:=1 to n do begin
        new(a[i]);
        for j:=1 to m do
           read(f,a[i]^[j]);
        readln(f);
                      end;
     close(f);
end;

procedure copy;
begin
     new(b);
     for i:=1 to n do
        for j:=1 to m do
           b^[(i-1)*m+j]:=a[i]^[j];
end;

procedure qsort(li,ls:longint);
var i,j:longint;
begin
     i:=li;
     j:=ls;
     med:=b^[(li+ls) shr 1];
     repeat
           while b^[i]<med do i:=i+1;
           while b^[j]>med do j:=j-1;
           if i<=j then begin
             aux:=b^[i];
             b^[i]:=b^[j];
             b^[j]:=aux;
             i:=i+1;
             j:=j-1;
                        end;
     until i>j;
     if li<j then qsort(li,j);
     if i<ls then qsort(i,ls);
end;

procedure indici;
begin
     new(c);
     prev:=-maxlongint;
     crt:=0;
     for i:=1 to n do
        for j:=1 to m do begin
           if b^[(i-1)*m+j]>prev then begin
             crt:=crt+1;
             prev:=b^[(i-1)*m+j];
                                      end;
           c^[(i-1)*m+j]:=crt;
                         end;
end;

function cauta(li,ls:longint;var what:longint):longint;
begin
     med:=(li+ls) div 2;
     if what<b^[med] then cauta:=cauta(1,med-1,what)
     else
         if what=b^[med] then cauta:=c^[med]
         else cauta:=cauta(med+1,ls,what);
end;

procedure convert;
begin
     copy;
     qsort(1,n*m);
     indici;
     for i:=1 to n do
        for j:=1 to m do
           a[i]^[j]:=cauta(1,n*m,a[i]^[j]);
end;

procedure init;
begin
     max:=0;
     for i:=1 to n*m do begin
        s[i]:=0;
        nr[i]:=0;
                        end;
end;

procedure analyze;
begin
     u:=0;
     total:=0;
     for p:=0 to m-1 do begin
        stop:=0;
        if u<p then u:=p;
        repeat
              u:=u+1;
              if u<=m then begin
                if over[u]=1 then stop:=1
                else begin
                    add:=0;
                    for v:=1 to l[u] do
                       if s[dif[u,v]]<>1 then add:=add+1;
                    if total+add<=k then begin
                      for v:=1 to l[u] do
                         if s[dif[u,v]]<>1 then begin
                           s[dif[u,v]]:=1;
                           nr[dif[u,v]]:=1;
                           total:=total+1;
                                                end
                         else nr[dif[u,v]]:=nr[dif[u,v]]+1;
                                         end
                    else stop:=1;
                     end;
                           end
              else stop:=1;
        until stop=1;
        u:=u-1;
        if (j-i+1)*(u-p)>max then begin
          max:=(j-i+1)*(u-p);
          lmic:=i;
          lmare:=j;
          cmic:=p+1;
          cmare:=u;
                                    end;
        if over[p+1]=0 then
          for v:=1 to l[p+1] do begin
             if nr[dif[p+1,v]]=1 then begin
               total:=total-1;
               s[dif[p+1,v]]:=0;
                                      end;
             nr[dif[p+1,v]]:=nr[dif[p+1,v]]-1;
                                end;
                        end;
end;

procedure work;
begin
     for i:=1 to n do begin
        for h:=1 to m do begin
           l[h]:=1;
           dif[h,1]:=a[i]^[h];
           cate[h,1]:=1;
           over[h]:=0;
                         end;
        j:=i;
        if m>max then analyze;
        for j:=i+1 to n do begin
           for h:=1 to m do
              if over[h]=0 then begin
                pz:=0;
                for v:=1 to l[h] do
                   if dif[h,v]=a[j]^[h] then pz:=v;
                if pz=0 then begin
                  if l[h]=k then over[h]:=1
                  else begin
                      l[h]:=l[h]+1;
                      dif[h,l[h]]:=a[j]^[h];
                       end;
                             end
                else cate[h,pz]:=cate[h,pz]+1;
                                end;
           if (j-i+1)*m>max then analyze;
                           end;
                      end;
end;

procedure scrie;
begin
     assign(f,no);rewrite(f);
     writeln(f,max);
     writeln(f,lmic,' ',cmic,' ',lmare,' ',cmare);
     close(f);
end;

begin {programul principal}
     load;
     convert;
     init;
     work;
     scrie;
end.