Program P_Sablon;
const MaxMN=255;
type Sablon=string[MaxMN];
     Intermediar=array[0..MaxMN,'a'..'z'] of 0..MaxMN;
var
  M,                 { lungimea cuvantului de inceput }
  N:Word;            { lungimea cuvantului de sfarsit }
  A,                 { cuvantul de inceput }
  B:Sablon;          { cuvantul de sfarsit }
  Nr_sol:Comp;       { solutia: numar sabloane bune }
  EPoz,UPoz:Longint; { prima pozitie buna }
  DA,DB:Intermediar; { tabelele intermediare ale automatului }
  Aq,Bq:Word;        { starile actuale ale automatelor }


procedure citeste;
var SablonF:Text;
  i:Word;
begin
  Assign(SablonF,'SABLON.IN'); Reset(SablonF);
  ReadLn(SablonF,A);
  M:=Length(A);
  ReadLn(SablonF,B);
  N:=Length(B);
  Close(SablonF)
end;

procedure Scrie;
var fo:Text;
    Maxh:Longint;
begin
  Assign(fo,'SABLON.OUT'); Rewrite(fo);
  WriteLn(fo,Nr_sol:1:0);
  if (Epoz>0) and (UPoz>0)
  then WriteLn(fo,EPoz-M+1:1,' ',UPoz-EPoz+M:1)
  else WriteLn(fo,0:1,' ',0:1);
  Close(fo)
end;

type sir=record
           tab:array[0..MaxMN+2] of Longint;
           inceput,sfarsit:0..MaxMN+2
         end;
var S:sir;

procedure In_sir(P:Longint);
begin
  S.tab[S.sfarsit]:=P;
  Inc(S.sfarsit);
  if S.sfarsit>MaxMN then S.sfarsit:=0
end;

procedure Din_sir;
begin
  Inc(S.inceput);
  if S.inceput>MaxMN then S.inceput:=0
end;

function Primul:Longint;
begin
  Primul:=S.tab[S.inceput]
end;

procedure Calculeaza;
var fis_text:Text;
    Buf:array[1..40000] of Char; { buffer }
    X:Char;         { caracterul actual }
    Inc_Bun:Longint; { numarul cuvintelor care incep cu A si
                      au lungimea cel putin M+N }
    Poz,P:Longint;  { pozitia actuala }

  procedure automatul(var S:Sablon; M:Word; var D:Intermediar);
  type tab_pref=array[1..MaxMN] of Word;
  var P:tab_pref;
  { calcularea functiilor de trecere ale automatului }

  procedure Prefix(var S:Sablon; M:Word);
  var k,q:Word;
  begin
    P[1]:=0; k:=0;
    for q:= 2 to M do
    begin
      while (k>0) and (S[k+1]<>S[q]) do k:=P[k];
      if S[k+1]=S[q] then Inc(k);
      P[q]:=k
    end
  end (* Prefix *) ;

  var q,qq:Word;
      x:Char;

  begin { automatul }
    Prefix(S,M);
    for q:=0 to M do
      for x:='a' to 'z' do
      begin
        if q=M then qq:=P[q]
               else qq:=q;
        while (qq>0) and (S[qq+1]<>X) do qq:=P[qq];
        if S[qq+1]=X then Inc(qq);
        D[q,x]:=qq
      end
  end{automatul};

Begin {Calculeaza}
  Assign(fis_text,'TEXT.IN');
{  SetTextBuf(fis_text,Buf,40000);}
  Reset(fis_text);
  S.inceput:=0; S.sfarsit:=0;
  Nr_sol:=0; Inc_Bun:=0;
  Epoz:=0; Upoz:=0;
  Poz:=0;
  Aq:=0; Bq:=0;
  automatul(A,M,DA);     { construirea automatelor }
  automatul(B,N,DB);

  while not EoLn(fis_text) do
  begin
    Read(fis_text,X);
    Inc(Poz);

    Aq:=DA[Aq,X];    { determinarea trecerilor din tabel }
    Bq:=DB[Bq,X];

    if Aq=M then In_sir(poz);     { am gasit cuvant de inceput }
    if S.inceput<>S.sfarsit
    then
    begin
      p:=Primul;
      if p+N<=poz
      then
      begin     { scoatem pozitia cuvantului "vechi" }
        Din_sir;
        Inc(Inc_Bun);
        if EPoz=0 then EPoz:=P     { prima pozitie de inceput buna}
      end
    end;

    if (Inc_Bun>0) and (Bq=N)
    then
    begin { am depistat un sfarsit }
      Nr_sol:=Nr_sol+Inc_Bun;
      if Poz>UPoz then UPoz:=Poz
    end
  end; { while }
  Close(fis_text)
end; { Calculeaza}

Begin { Program }
  Citeste;
  Calculeaza;
  Scrie
End.
