{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65384,0,655360}

program Pendula;

   const prec=0.000001;

   type vect=array[1..100]of real;

   var f:text;
       a:array[1..100]of ^vect;
       x,y:array[1..100]of real;
       act,n:byte;
       aa,bb,cc:real;
       r:real;

procedure ReadData;
   var i,j:byte;
   begin
    assign(f,'pendula.in');
    reset(f);
    readln(f,r);
    readln(f,n);
    for i:=1 to n do readln(f,x[i],y[i]);
    close(f);
    for i:=1 to n do new(a[i]);
    for i:=1 to n do
     begin
      for j:=i+1 to n do
       begin
         a[i]^[j]:=sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]));
         a[j]^[i]:=a[i]^[j];
       end;
      a[i]^[i]:=0;
     end;
   end;

function GetFel(i:byte):byte;
   var rez:real;
   begin
    rez:=x[i]*aa+y[i]*bb+cc;
    if abs(rez)<=prec then
     begin
      getfel:=1;
      exit;
     end;
    if rez<0 then
     begin
      getfel:=0;
      exit;
     end;
    getfel:=2;
   end;

function stanga(i,j:byte):integer;
   var rez:Real;
   begin
    rez:=(x[i]-x[act])*(y[j]-y[act])-(y[i]-y[act])*(x[j]-x[act]);
    if abs(rez)<=prec then
     begin
      stanga:=0;
      exit;
     end;
    if rez<0 then
     begin
      stanga:=-1;
      exit;
     end;
    stanga:=1;
   end;

procedure Rezolva;
   var sw:boolean;
       i,j,fel,aux:shortint;
       dist:real;
   begin
    sw:=true;
    act:=1;
    dist:=-100; j:=0;
    for i:=2 to n do if y[i]=y[1] then if x[i]<x[1] then if a[i]^[1]<r then
    if a[i]^[1]>dist then
     begin
      j:=i;
      dist:=a[i]^[1];
     end;
    assign(f,'pendula.out');
    rewrite(f);
    if j<>0 then
     begin
      writeln(f,j);
      r:=r-a[1]^[j];
      act:=j;
     end;
    aa:=0;
    bb:=1;
    cc:=-y[act];
    while sw do
     begin
      sw:=false;
      for i:=1 to n do if i<>act then if a[act]^[i]<r then
       begin
        if not sw then
         begin
          sw:=true;
          j:=i;
          fel:=GetFel(i);
         end
        else
         begin
           aux:=getfel(i);
          if aux<fel then
            begin
             j:=i;
             fel:=aux;
            end
           else if aux=fel then
            begin
             aux:=stanga(i,j);
             if aux<0 then
              begin
              end
             else if aux=0 then
              begin
               if a[act]^[i]>a[act]^[j] then
                begin
                 j:=i;
                end;
              end
             else
              begin
               j:=i;
              end;
            end;
         end;
       end;
      if sw then
       begin
        r:=r-a[j]^[act];
        aa:=y[j]-y[act];
        bb:=x[act]-x[j];
        cc:=-aa*x[j]-bb*y[j];
        act:=j;
        writeln(f,j);
       end;
     end;
    close(f);
   end;

begin
 Readdata;
 rezolva;
end.


