#include <stdio.h>
#include <stdlib.h>

int n;
unsigned cine[1000];
int total;

typedef struct _nod {
	int calc;
	struct _nod *urm;
} nod;

nod *next[1000][5];
nod *prev[1000][5];
int bitcount[32];

int bit_count(int a)
{
	unsigned tmp;
	tmp=a;
	tmp=(tmp&0x5555)+((tmp&0xaaaa)>>1);
	tmp=(tmp&0x3333)+((tmp&0xcccc)>>2);
	tmp=(tmp&0x0f0f)+((tmp&0xf0f0)>>4);
	tmp=(tmp&0x00ff)+((tmp&0xff00)>>8);
	return tmp;
}

void citprel(void)
{
	FILE * fin;
	int i,j,k;
	unsigned char *tata[32];
	int *cost[32];
	int foo,bar,baz;
	nod *tmp,*curr;

	if(!(fin=fopen("HACKER.IN","r"))){
		fprintf(stderr,"No can open input file :(\n");
		exit(42);
	}
	fscanf(fin,"%d",&n);
	for(i=0;i<32;i++){
		tata[i]=(char *)malloc(n*sizeof(char));
		cost[i]=(int *)malloc(n*sizeof(int));
	}
	for(i=0;i<n;i++){
		for(j=0;j<32;j++)
			cost[j][i]=5100;
	}
	for(i=0;i<n;i++)
		for(j=0;j<5;j++)
			next[i][j]=prev[i][j]=NULL;
	for(i=0;i<n-1;i++){
		fscanf(fin,"%d",&foo);
		for(j=0;j<foo;j++){
			fscanf(fin,"%d%d",&bar,&baz);
			bar--;baz--;
			tmp=(nod *)malloc(sizeof(nod));
			tmp->calc=baz;
			tmp->urm=next[i][bar];
			next[i][bar]=tmp;
			tmp=(nod *)malloc(sizeof(nod));
			tmp->calc=bar;
			tmp->urm=prev[i][baz];
			prev[i][baz]=tmp;
		}
	}
	fclose(fin);

	/* prelucrare */
	for(i=0;i<32;i++){
		bitcount[i]=bit_count(i);
	}
	for(i=0;i<32;i++){
		foo=0;
		for(j=0;j<5;j++)
			foo+=1&(i>>j);
		cost[i][0]=foo;
	}

	for(i=1;i<n;i++){
		for(j=0;j<32;j++){
			if(cost[j][i-1]>5000)continue;
			/* calcul masca obligatorie -> foo */
			foo=0;
			for(k=0;k<5;k++){
				if(j&(1<<k)) continue;
				curr=next[i-1][k];
				while(curr){
					foo =foo | (1 << curr->calc);
					curr=curr->urm;
				}
			}
			for(k=0;k<32;k++){
				if(foo!=(foo & k))continue;
				bar=bitcount[k];
				if(cost[k][i]>(cost[j][i-1]+bar)){
					cost[k][i]=cost[j][i-1]+bar;
					tata[k][i]=j;
				}
			}
		}
	}
	/* reconstruire ... */
	foo=0;
	for(i=0;i<32;i++){
		if(cost[i][n-1]<cost[foo][n-1])
			foo=i;
	}
	bar=foo;
	for(i=n-1;i>=0;i--){
		cine[i]=foo;
		foo=tata[foo][i];
	}
	total=cost[bar][n-1];
	/* gata! */
}

void afis(void)
{
	FILE * fout;
	int i,j;

	if(!(fout=fopen("HACKER.OUT","w"))){
		fprintf(stderr,"No can open output file :(\n");
		exit(42);
	}

	fprintf(fout,"%d\n",total);
	for(i=0;i<n;i++){
		for(j=0;j<5;j++)
			if(cine[i]&(1<<j))
				fprintf(fout,"%d ",j+1);
		fprintf(fout,"\n");
	}
	fclose(fout);
}

int main(void)
{
	citprel();
	afis();

	return 0;
}


