// Dumitran Daniel

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define fisin 			"scrabble.in"
#define fisout			"scrabble.out"
#define maxnr			  15
#define maxn     	  30
#define maxm			  30
#define maxlen			11
#define maxrep			4
#define nrlit       26
#define nolit			  0x7777
#define empty  		  0

struct pozitie{
	char x,y;
	char d;
	};

struct litinfo{
	char x,y;
	};

FILE *f;
int nr,m,n;
char cuv[maxnr][maxlen];
char mat[maxm][maxn];
char rep[maxm][maxn];
pozitie st[maxnr],sol[maxnr];
int i,j;
litinfo lit[nrlit][maxnr*maxrep];
int nlit[nrlit];
int poz[maxm][maxn];
int best[maxnr];
int k;
int rez;
int pi,pl,ti,tl,tt,ci,crez;
pozitie start[maxnr][800];
int nrstart[maxnr];
unsigned long far *timer;
unsigned long alarm;

void putword(char c[maxlen],int px,int py,char pd)
{
	st[k].x=px;st[k].y=py;st[k].d=pd;
	if(pd=='O'){
		for(pi=0;c[pi];pi++){
			pl=c[pi];
			mat[px][py+pi]=pl;
			pl-='A';
			rep[px][py+pi]++;
			if(poz[px][py+pi]==nolit){
				lit[pl][nlit[pl]].x=px;
				lit[pl][nlit[pl]].y=py+pi;
				poz[px][py+pi]=nlit[pl];
				nlit[pl]++;
				}
			}
		return;
		}

	for(pi=0;c[pi];pi++){
		pl=c[pi];
		mat[px+pi][py]=pl;
    pl-='A';
		rep[px+pi][py]++;
		if(poz[px+pi][py]==nolit){
			lit[pl][nlit[pl]].x=px+pi;
			lit[pl][nlit[pl]].y=py;
			poz[px+pi][py]=nlit[pl];
			nlit[pl]++;
			}
		}
	}

void takeword(char c[maxlen],int tx,int ty,char td)
{
	st[k].x=-1;st[k].y=-1;st[k].d='X';
	if(td=='O'){
		for(ti=ty;c[ti-ty];ti++){
			tl=mat[tx][ti]-'A';
			rep[tx][ti]--;
			if(!rep[tx][ti]){
				mat[tx][ti]=empty;
				tt=poz[tx][ti];
				poz[tx][ti]=nolit;
				nlit[tl]--;
				if(nlit[tl]!=tt){
					lit[tl][tt]=lit[tl][nlit[tl]];
					poz[lit[tl][tt].x][lit[tl][tt].y]=tt;
					}
				}
			}
		return;
		}

	for(ti=tx;c[ti-tx];ti++){
		tl=mat[ti][ty]-'A';
		rep[ti][ty]--;
		if(!rep[ti][ty]){
			mat[ti][ty]=empty;
			tt=poz[ti][ty];
			poz[ti][ty]=nolit;
			nlit[tl]--;
			if(nlit[tl]!=tt){
				lit[tl][tt]=lit[tl][nlit[tl]];
				poz[lit[tl][tt].x][lit[tl][tt].y]=tt;
				}
			}
		}
	}

void updatebest(int stpoz,int brez)
{
	best[stpoz]=brez;
	for(int ui=stpoz+1;ui<nr;ui++) best[ui]=0;
	}

int count(char c[maxlen],int cx,int cy,char cd)
{
	crez=0;
	if((cx<0)||(cx>=m)||(cy<0)||(cy>=n)) return 0;
	if(cd=='O'){
		for(ci=0;c[ci];ci++){
			if(cy+ci>=n) return 0;
			if(mat[cx][cy+ci]){
				if(mat[cx][cy+ci]!=c[ci]) return 0;
				crez++;
				}
			}
		return crez;
		}

	for(ci=0;c[ci];ci++){
		if(cx+ci>=m) return 0;
		if(mat[cx+ci][cy]){
			if(mat[cx+ci][cy]!=c[ci]) return 0;
			crez++;
			}
		}
	return crez;
	}

void back()
{

	int bi,bj,bl;

	if(k==nr-1){
		for(i=0;i<nr;i++) sol[i]=st[i];
		return;
		}

	if(*timer>=alarm){
	 f=fopen(fisout,"wt");
		for(i=1;i<nr;i++)
			fprintf(f,"%d %d %c\n",sol[i].x+1,sol[i].y+1,sol[i].d);
		fclose(f);
		_exit(0);
		}
	k++;

	nrstart[k]=0;
	for(bi=0;cuv[k][bi];bi++){
    bl=cuv[k][bi]-'A';
		for(bj=0;bj<nlit[bl];bj++){
//Vertical
			ti=lit[bl][bj].x-bi;tl=lit[bl][bj].y;
			rez=count(cuv[k],ti,tl,'V');
			if(rez>best[k]) {updatebest(k,rez);nrstart[k]=0;}
			if((rez==best[k])&&(rez)){
				start[k][nrstart[k]].x=ti;start[k][nrstart[k]].y=tl;start[k][nrstart[k]].d='V';
				nrstart[k]++;
				for(tt=0;tt<nrstart[k]-1;tt++)
					if((start[k][tt].x==ti)&&(start[k][tt].y==tl)&&(start[k][tt].d=='V')){
						nrstart[k]--;
						break;
						}
				}

//Orizontal
			ti=lit[bl][bj].x;tl=lit[bl][bj].y-bi;
			rez=count(cuv[k],ti,tl,'O');
			if(rez>best[k]) {updatebest(k,rez);nrstart[k]=0;}
			if((rez==best[k])&&(rez)) {
				start[k][nrstart[k]].x=ti;start[k][nrstart[k]].y=tl;start[k][nrstart[k]].d='O';
				nrstart[k]++;
				for(tt=0;tt<nrstart[k]-1;tt++)
					if((start[k][tt].x==ti)&&(start[k][tt].y==tl)&&(start[k][tt].d=='O')){
						nrstart[k]--;
						break;
						}
				}
			}
		}

	if(best[k])
		for(bi=0;bi<nrstart[k];bi++){
			putword(cuv[k],start[k][bi].x,start[k][bi].y,start[k][bi].d);
			back();
			takeword(cuv[k],start[k][bi].x,start[k][bi].y,start[k][bi].d);
      if(k+1==nr) break;
			}

	k--;
	}



void main()
{
	timer=(unsigned long far *)0x0040006cl;
	alarm=*timer+35;

	f=fopen(fisin,"rt");
	fscanf(f,"%d %d %d",&nr,&m,&n);
	fscanf(f,"%d %d %c",&st[0].x,&st[0].y,&st[0].d);
	for(i=0;i<nr;i++)
		fscanf(f,"%s",cuv[i]);
	fclose(f);

	for(i=0;i<m;i++)
		for(j=0;j<n;j++)
			poz[i][j]=nolit;
	st[0].x--;st[0].y--;

	putword(cuv[0],st[0].x,st[0].y,st[0].d);

	k=0;

	back();

	if(!best[nr-1]){
		printf("Nu exista solutie.");
		f=fopen(fisout,"wt");
		for(i=1;i<nr;i++)
			fprintf(f,"1 1 O\n");
		fclose(f);
		_exit(0);
		}

	printf("Am terminat .... ");
	f=fopen(fisout,"wt");
	for(i=1;i<nr;i++)
		fprintf(f,"%d %d %c\n",sol[i].x+1,sol[i].y+1,sol[i].d);
	fclose(f);
	}
