{ Mugurel Ionut Andreica }
{$S-,I-,R-,Q-}
{$M 65000,0,655360}

Program PolySticks;

type dir=(N,E,S,V);
     bytevect=array[-150..150] of byte;

const fi='poly.in';
      fo='poly.out';
      bit:array[dir] of byte=(1,2,4,8);

var fin,fout:text;
    xco,yco:array[1..100] of integer;
    a:array[-150..150] of ^bytevect;
    i,j,k,np,nsg,minx,miny,maxx,maxy,nfig,px,py,vaux:integer;
    oriz,vert,dpri,dsec:boolean;
    ao,bo,co,av,bv,cv,adp,bdp,cdp,ads,bds,cds:real;

function semn(a,b,c:real;x,y:longint):shortint;
var r:real;
begin
r:=a*x+b*y+c;
if (r=0) then semn:=0
else
if (r<0) then semn:=-1
else semn:=1;
end;


function simetrieoriz:boolean;
var ci,cj,ai,aj:integer;
    ok:boolean;

begin

px:=0;
if maxx=0 then begin
px:=1;
maxx:=maxx+px;
               end;

ao:=0;
bo:=maxx;
co:=minx*maxy/2-maxx*maxy/2;

maxx:=maxx-px;

ok:=true;

for ci:=minx to maxx do
begin

for cj:=miny to maxy do
begin

ai:=ci;
aj:=maxy-cj;

if ((a[ci]^[cj] and bit[N])<>(a[ai]^[aj] and bit[S] shr 2)) or
   ((a[ci]^[cj] and bit[E] shr 1)<>(a[ai]^[aj] and bit[E] shr 1)) or
   ((a[ci]^[cj] and bit[S] shr 2)<>(a[ai]^[aj] and bit[N])) or
   ((a[ci]^[cj] and bit[V] shr 3)<>(a[ai]^[aj] and bit[V] shr 3))
then ok:=false;

if not ok then break;
end;

if not ok then break;
end;

simetrieoriz:=ok;

end;

function simetrievert:boolean;
var ci,cj,ai,aj:integer;
    ok:boolean;
begin

py:=0;
if maxy=0 then begin
py:=1;
maxy:=maxy+py;
               end;

av:=maxy;
bv:=0;
cv:=maxx/2*miny-maxx/2*maxy;

maxy:=maxy-py;

ok:=true;

for ci:=minx to maxx do
begin

for cj:=miny to maxy do
begin

ai:=maxx-ci;
aj:=cj;

if ((a[ci]^[cj] and bit[N])<>(a[ai]^[aj] and bit[N])) or
   ((a[ci]^[cj] and bit[E] shr 1)<>(a[ai]^[aj] and bit[V] shr 3)) or
   ((a[ci]^[cj] and bit[S] shr 2)<>(a[ai]^[aj] and bit[S] shr 2)) or
   ((a[ci]^[cj] and bit[V] shr 3)<>(a[ai]^[aj] and bit[E] shr 1))
then ok:=false;

if not ok then break;
end;

if not ok then break;
end;

simetrievert:=ok;

end;

function simetriedpri:boolean;
var ci,cj,ai,aj,sm1,sm2:integer;
    ok:boolean;
begin

px:=0;
if maxx=0 then begin
px:=1;
maxx:=maxx+px;
               end;
py:=0;
if maxy=0 then begin
py:=1;
maxy:=maxy+py;
               end;


adp:=maxy/2;
bdp:=maxy/2;
cdp:=-(maxx/2+maxy/2)*maxy/2;

maxx:=maxx-px;
maxy:=maxy-py;

px:=0;
py:=0;
if (maxx<maxy) then begin
vaux:=maxx;
maxx:=maxy;
px:=1;
                    end
else begin
vaux:=maxy;
maxy:=maxx;
py:=1;
     end;

ok:=true;

for ci:=minx to maxx do
begin

for cj:=miny to maxy do
begin

ai:=maxy-cj;
aj:=maxx-ci;

sm1:=semn(adp,bdp,cdp,ci,cj);
sm2:=semn(adp,bdp,cdp,ai,aj);

if (((a[ci]^[cj] and bit[N])<>(a[ai]^[aj] and bit[V] shr 3)) or
   ((a[ci]^[cj] and bit[E] shr 1)<>(a[ai]^[aj] and bit[S] shr 2)) or
   ((a[ci]^[cj] and bit[S] shr 2)<>(a[ai]^[aj] and bit[E] shr 1)) or
   ((a[ci]^[cj] and bit[V] shr 3)<>(a[ai]^[aj] and bit[N]))) and
   (sm1<>sm2)
then ok:=false;

if not ok then break;
end;

if not ok then break;
end;

if px=1 then maxx:=vaux
else maxy:=vaux;

simetriedpri:=ok;

end;

function simetriedsec:boolean;
var ci,cj,ai,aj,sm1,sm2:integer;
    ok:boolean;
begin

px:=0;
if maxx=0 then begin
px:=1;
maxx:=maxx+px;
               end;
py:=0;
if maxy=0 then begin
py:=1;
maxy:=maxy+py;
               end;


ads:=-maxy/2;
bds:=maxy/2;
cds:=(maxx/2-maxy/2)*maxy/2;

maxx:=maxx-px;
maxy:=maxy-py;

px:=0;
py:=0;
if (maxx<maxy) then begin
vaux:=maxx;
maxx:=maxy;
px:=1;
                    end
else begin
vaux:=maxy;
maxy:=maxx;
py:=1;
     end;

ok:=true;

for ci:=minx to maxx do
begin

for cj:=miny to maxy do
begin

aj:=ci;
ai:=cj;

sm1:=semn(ads,bds,cds,ci,cj);
sm2:=semn(ads,bds,cds,ai,aj);

if (((a[ci]^[cj] and bit[N])<>(a[ai]^[aj] and bit[E] shr 1)) or
   ((a[ci]^[cj] and bit[E] shr 1)<>(a[ai]^[aj] and bit[N])) or
   ((a[ci]^[cj] and bit[S] shr 2)<>(a[ai]^[aj] and bit[V] shr 3)) or
   ((a[ci]^[cj] and bit[V] shr 3)<>(a[ai]^[aj] and bit[S] shr 2))) and
   (sm1<>sm2)
then ok:=false;

if not ok then break;
end;

if not ok then break;
end;

if px=1 then maxx:=vaux
else maxy:=vaux;

simetriedsec:=ok;

end;

function inside(x,y:integer):boolean;
var ok:boolean;
begin
ok:=true;
if oriz then
ok:=ok and (semn(ao,bo,co,x,y)>=0);
if vert then
ok:=ok and (semn(av,bv,cv,x,y)>=0);
if dpri then
ok:=ok and (semn(adp,bdp,cdp,x,y)>=0);
if dsec then
ok:=ok and (semn(ads,bds,cds,x,y)>=0);

inside:=ok;

end;

begin
assign(fin,fi);
reset(fin);
readln(fin,np,nsg);

minx:=maxint;
miny:=maxint;
maxx:=-maxint;
maxy:=-maxint;

for i:=1 to np do
begin
readln(fin,xco[i],yco[i]);
if xco[i]<minx then minx:=xco[i];
if yco[i]<miny then miny:=yco[i];
if xco[i]>maxx then maxx:=xco[i];
if yco[i]>maxy then maxy:=yco[i];
end;

minx:=-minx;
miny:=-miny;

for i:=1 to np do
begin
xco[i]:=xco[i]+minx;
yco[i]:=yco[i]+miny;
end;

maxx:=maxx+minx;
maxy:=maxy+miny;
minx:=0;
miny:=0;


for i:=-150 to 150 do begin
new(a[i]);
fillchar(a[i]^,sizeof(a[i]^),0);
                      end;

for k:=1 to nsg do
begin
readln(fin,i,j);

if xco[i]=xco[j] then
begin
if yco[i]<yco[j] then begin
a[xco[i]]^[yco[i]]:=a[xco[i]]^[yco[i]] or bit[N];
a[xco[i]]^[yco[j]]:=a[xco[i]]^[yco[j]] or bit[S];
                      end
else begin
a[xco[i]]^[yco[i]]:=a[xco[i]]^[yco[i]] or bit[S];
a[xco[i]]^[yco[j]]:=a[xco[i]]^[yco[j]] or bit[N];
     end;
end
else
begin
if xco[i]<xco[j] then begin
a[xco[i]]^[yco[i]]:=a[xco[i]]^[yco[i]] or bit[E];
a[xco[j]]^[yco[i]]:=a[xco[j]]^[yco[i]] or bit[V];
                      end
else begin
a[xco[i]]^[yco[i]]:=a[xco[i]]^[yco[i]] or bit[V];
a[xco[j]]^[yco[i]]:=a[xco[j]]^[yco[i]] or bit[E];
     end;
end;

end;

close(fin);


oriz:=simetrieoriz;
vert:=simetrievert;
dpri:=simetriedpri;
dsec:=simetriedsec;


nfig:=0;

for k:=1 to np do
if (inside(xco[k],yco[k])) then
begin

i:=xco[k];
j:=yco[k];

if (a[i]^[j] and bit[N]=0) and (inside(i,j+1)) then
begin
nfig:=nfig+1;
a[i]^[j+1]:=a[i]^[j+1] or bit[S];
end;

if (a[i]^[j] and bit[E]=0) and (inside(i+1,j)) then
begin
nfig:=nfig+1;
a[i+1]^[j]:=a[i+1]^[j] or bit[V];
end;

if (a[i]^[j] and bit[S]=0) and (inside(i,j-1)) then
begin
nfig:=nfig+1;
a[i]^[j-1]:=a[i]^[j-1] or bit[N];
end;

if (a[i]^[j] and bit[V]=0) and (inside(i-1,j)) then
begin
nfig:=nfig+1;
a[i-1]^[j]:=a[i-1]^[j] or bit[E];
end;

end;

assign(fout,fo);
rewrite(fout);
writeln(fout,nfig);
close(fout);

end.