program pendula;

const ni='pendula.in';
      no='pendula.out';
      nmax=100;
      eps=0.00001;

type sir=array [1..nmax] of real;
     psir=^sir;
     mat=array [1..nmax] of psir;

var f:text;
    n,i,j,lng1,lng2,lng3,lng4,sgn,chosen,p:integer;
    x,y,c1,c2,c3,c4,d1,d2,d3,d4:sir;
    dis:mat;
    s,l1,l2,l3,l4:array [1..nmax] of integer;
    xp,yp,xc,yc,dl,dx,dy,nl,l,d,carac,dist,minx,maxx,miny,maxy,vali,
    ll,aa,bb,cc,rap,sus,jos:real;
    term:boolean;
    time:longint absolute $0000:$046C;
    ts,tf:longint;

procedure load;
begin
     assign(f,ni);reset(f);
     readln(f,l);
     readln(f,n);
     readln(f,xp,yp);
     x[1]:=xp;
     y[1]:=yp;
     for i:=2 to n do
        read(f,x[i],y[i]);
     close(f);
end;

procedure init;
begin
     p:=1;
     xc:=xp-l;
     yc:=yp;
     for i:=1 to n do
        new(dis[i]);
     for i:=1 to n-1 do
        for j:=i+1 to n do begin
           dis[i]^[j]:=sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]));
           dis[j]^[i]:=dis[i]^[j];
                           end;
end;

function terminal:boolean;
begin
     terminal:=true;
     ll:=sqr(l);
     for i:=1 to n do begin
        d:=sqr(x[i]-xp)+sqr(y[i]-yp);
        if d>eps then
          if ll-d>eps then begin
            s[i]:=1;
            terminal:=false;
                          end
          else s[i]:=0;
                      end;
end;

procedure compute;
begin
     if xp<xc then begin
       minx:=xp;
       maxx:=xc;
                   end
     else begin
         minx:=xc;
         maxx:=xp;
          end;
     if yp<yc then begin
       miny:=yp;
       maxy:=yc;
                   end
     else begin
         miny:=yc;
         maxy:=yp;
          end;
     lng1:=0;
     lng2:=0;
     lng3:=0;
     lng4:=0;
     for i:=1 to n do
        if s[i]=1 then begin
          vali:=(x[i]-xp)*(yc-yp)-(y[i]-yp)*(xc-xp);
          if vali>eps then sgn:=1
          else
              if vali<-eps then sgn:=-1
              else sgn:=0;
          if sgn=0 then begin
            if (minx<x[i]) and (x[i]<maxx) and (miny<y[i]) and (y[i]<maxy) then begin
              lng1:=lng1+1;
              l1[lng1]:=i;
              c1[lng1]:=1;
              d1[lng1]:=sqr(x[i]-xp)+sqr(y[i]-yp);
                                                                                end
            else begin
                lng3:=lng3+1;
                l3[lng3]:=i;
                c3[lng3]:=-1;
                d3[lng3]:=sqr(x[i]-xp)+sqr(y[i]-yp);
                 end;
                        end
          else
              if sgn=-1 then begin
                lng2:=lng2+1;
                l2[lng2]:=i;
                aa:=sqr(xc-x[i])+sqr(yc-y[i]);
                bb:=sqr(l);
                cc:=sqr(xp-x[i])+sqr(yp-y[i]);
                sus:=bb+cc-aa;
                jos:=2*l*dis[p]^[i];
                c2[lng2]:=sus/jos;
                d2[lng2]:=cc;
                             end
              else begin
                  lng4:=lng4+1;
                  l4[lng4]:=i;
                  aa:=sqr(xc-x[i])+sqr(yc-y[i]);
                  bb:=sqr(l);
                  cc:=sqr(xp-x[i])+sqr(yp-y[i]);
                  sus:=bb+cc-aa;
                  jos:=2*l*dis[p]^[i];
                  c4[lng4]:=sus/jos;
                  d4[lng4]:=cc;
                   end;
                       end;
end;

procedure choose;
begin
     chosen:=0;
     if chosen=0 then begin
       carac:=0;
       dist:=-maxlongint;
       for i:=1 to lng1 do
          if d1[i]-dist>eps then begin
            chosen:=l1[i];
            dist:=d1[i];
                                 end;
                      end;
     if chosen=0 then begin
       carac:=-maxlongint;
       dist:=-maxlongint;
       for i:=1 to lng2 do
          if (c2[i]-carac>eps) or
             ((-eps<c2[i]-carac) and (c2[i]-carac<eps) and (d2[i]-dist>eps)) then begin
               chosen:=l2[i];
               carac:=c2[i];
               dist:=d2[i];
                                                                                  end;
                      end;
     if chosen=0 then begin
       carac:=0;
       dist:=-maxlongint;
       for i:=1 to lng3 do
          if d3[i]-dist>eps then begin
            chosen:=l3[i];
            dist:=d3[i];
                                 end;
                      end;
     if chosen=0 then begin
       carac:=maxlongint;
       dist:=-maxlongint;
       for i:=1 to lng4 do
          if (c4[i]-carac<-eps) or
             ((-eps<c4[i]-carac) and (c4[i]-carac<eps) and (d4[i]-dist>eps)) then begin
               chosen:=l4[i];
               carac:=c4[i];
               dist:=d4[i];
                                                                                  end;
                      end;
end;

procedure change;
begin
     dl:=sqrt(sqr(xp-x[chosen])+sqr(yp-y[chosen]));
     nl:=l-dl;
     rap:=l/dl;
     dx:=x[chosen]-xp;
     dy:=y[chosen]-yp;
     xc:=xp+dx*rap;
     yc:=yp+dy*rap;
     xp:=x[chosen];
     yp:=y[chosen];
     l:=nl;
     p:=chosen;
end;

procedure work;
begin
     assign(f,no);rewrite(f);
     repeat
           term:=terminal;
           if not term then begin
             compute;
             choose;
             writeln(f,chosen);
             change;
                            end;
     until term;
     close(f);
end;

begin {programul principal}
{                           ts:=time;}
     load;
     init;
     work;
{                           tf:=time;}
{                           writeln(' ',((tf-ts)*0.055):0:2,' sec.');}
end.