Program Prison;
Uses Dos;

Type Link      = ^Prizonier;
     Inaltime  = 0..MAXLONGINT;
     Prizonier = Record
                    Cod   : Word;
                    Inalt : Inaltime;
                    Next  : Link
                 End;
     Cifre     = 0..9;

Var f, g           : Text;
    First          : Array[Cifre] Of Link;
    FirstC, p      : Link;
    Cifra          : Cifre;
    n, i           : Word;
    HString, NumeF : String;
    MaxCifre, c    : Byte;
    h,z            : Inaltime;
    hh, m, s, ss   : Word;

Procedure CreazaCentral(x : Inaltime; c : Word);
Var q, r : Link;
Begin
   If FirstC = NIL Then
      Begin
          New(r);
          FirstC := r;
          r^.Inalt := x;
          r^.Cod := c;
          r^.Next := NIL
      End
   Else
      Begin
          q := FirstC;
          While q^.Next <> NIL Do q := q^.Next;
          New(r);
          q^.Next := r;
          r^.Inalt := x;
          r^.Cod := c;
          r^.Next := NIL
      End;
End;

Procedure ImparteInCoridoare(Zece : Inaltime);
Var i : Cifre;
    q, r : Link;

    Procedure PuneInCoridor;
    Begin
        Cifra := (p^.Inalt Div Zece) Mod 10;
        If First[Cifra] = NIL Then
           Begin
               New(q);
               First[Cifra] := q;
               q^.Inalt := p^.Inalt;
               q^.Cod := p^.Cod;
               q^.Next := NIL
           End
        Else
           Begin
               q := First[Cifra];
               While q^.Next <> NIL Do q := q^.Next;
               New(r);
               q^.Next := r;
               r^.Inalt := p^.Inalt;
               r^.Cod := p^.Cod;
               r^.Next := NIL
           End;
    End;
Begin
    For i := 0 To 9 Do First[i] := NIL;
    p := FirstC;
    While p <> NIL Do
        Begin
            PuneInCoridor;
            FirstC := p;
            p := p^.Next;
            Dispose(FirstC)
        End;
End;

Procedure RefaCoridorCentral;
Var h : Link;
Begin
    FirstC := NIL;
    For i := 0 To 9 Do
        Begin
            p := First[i];
            While p <> NIL Do
                Begin
                    CreazaCentral(p^.Inalt, p^.Cod);
                    h := p;
                    p := p^.Next;
                    Dispose(h)
                End;
        End
End;

Procedure AfiseazaCoridorCentral;
Begin
    p := FirstC;
    While p <> NIL Do
        Begin
            Write(g, p^.Cod,' ');
            p := p^.Next
        End;
    WriteLn(g, ' ')
End;

Begin
{    Write('Nume fisier intrare : '); ReadLn(NumeF);}
    Assign(f, {NumeF}'DETINUT.IN'); Reset(f);
    Assign(g, 'detinut.out'); ReWrite(g);
{    SetTime(0, 0, 0, 0);}
    ReadLn(f, n);
    MaxCifre := 0;
    FirstC := NIL;
    For i := 1 To n Do
        Begin
            ReadLn(f, h);
            Str(h, HString);
            If Length(HString) > MaxCifre Then MaxCifre := Length(HString);
            CreazaCentral(h, i)
        End;
    z := 1;
    For c := 1 To MaxCifre Do
        Begin
            ImparteInCoridoare(z);
            RefaCoridorCentral;
            AfiseazaCoridorCentral;
            z := z * 10
        End;
{    GetTime(hh, m, s, ss);
    WriteLn('Timp de executie : ', hh, ':', m, ':', s, '.', ss);}
    Close(f);
    Close(g);
End.
