{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16000,0,10000}

unit joc;

interface

  procedure MutareaMea(nr : longint);
  procedure MutareaTa(var nr : longint);

implementation

  uses
    dos,windos,crt;

  const
    MaxN = 1000;
    MM = 1;{timp maxim de joc }

  type
    intproc = procedure(flags : word);

  var
    {variabile necesare evaluatorului}
    regs : TRegisters;
    old8h : intproc;
    p : pointer;
    ok_ : ^byte;
    timp,ts,e,maxtimp : word;
    int08seg,int08ofs : word;

    {variabile necesare programului}
    f,fo : text;
    a : array[1..MaxN] of longint;
    c : array[1..MaxN] of boolean;

    i,j,n : word;
    Nr_Diferite : word;

    mutarea_ta : boolean;

  const frez : string='C:\BARAJ\JOC\DATE\REZULTAT.TXT'; { Fisierul cu rezultate }

procedure Inv;
  var i :integer;
      sc : longint;
begin
  for i := 1 to Nr_Diferite div 2 do
  begin
    sc := a[i];
    a[i] := a[Nr_Diferite+1-i];
    a[Nr_Diferite+1-i] := sc;
  end;
end;

procedure Sort(l, r: word);
  var i, j : word;
      y,x : longint;
begin
  i := l; j := r;
  x := a[(l+r) DIV 2];
  repeat
    while a[i] < x do i := i + 1;
    while x < a[j] do j := j - 1;
    if i <= j
    then begin
           y := a[i]; a[i] := a[j]; a[j] := y;
           i := i + 1; j := j - 1;
         end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

function CalculeazaDiferente : word;
  var i,k : word;
      c1,c2,s : longint;
begin
  k := 1; s := 1;
  c1 := a[1];
  for i := 2 to n do
    if a[i]-a[s] <> 0
    then begin
           c2 := a[i] - a[s];
           a[k] := c1;
           c1 := c2;
           inc(k);
           s := i;
         end;
  if c1 <> 0
  then a[k] := c1;
  CalculeazaDiferente := k;
end;

procedure CalculeazaStrategie;
  var i : word;
begin
  c[1] := true;
  for i := 2 to Nr_Diferite do
    if a[i-1] > 1
    then c[i] := false
    else c[i] := not c[i-1];
end;

procedure new8h(flags : word); interrupt;
begin
{  old8h(flags);}
  asm
    mov al,20h
    out 20h,al
  end;
  inc(timp);
  if ok_^ = 0
  then begin
         if timp > maxtimp
         then begin
                writeln('Out of time');
                regs.ax := $4c00;
                msdos(regs);
              end;
       end;
end;

function final : boolean;
begin
  final := Nr_Diferite = 0;
end;

procedure Evaluare;
begin
  writeln('Jocul a fost rezolvat corect !');
  writeln(fo,0);
  close(fo);
{  setintvec(8,p);
  assign(f,frez);
  append(f);
  writeln(f, 12345);
  close(f);}
  halt;
end;

function Sigur : boolean;
begin
  if Nr_Diferite = 0
  then Sigur := false
  else if a[Nr_Diferite] = 1
       then Sigur := c[Nr_Diferite]
       else Sigur := true;
end;

procedure ExecutaMutare(nr : longint);
begin
  a[Nr_Diferite] := a[Nr_Diferite] - nr;
  if a[Nr_Diferite] = 0
  then dec(Nr_Diferite);
end;

procedure MutareaMea(nr : longint);
  var ok : boolean;
begin
  if final
  then begin
         writeln('>>> Nu mai sunt piese pe tabla si nu mai poti face mutari !!!');
         writeln(fo,1);
         close(fo);
         halt;
       end;
  if not mutarea_ta
  then begin
         writeln('>>> Nu este randul tau la mutare !');
         writeln(fo,1);
         close(fo);
         halt;
       end;
  if nr = 0
  then begin
         writeln('>>> Nu poti extrage 0 monede!');
         writeln(fo,1);
         close(fo);
         halt;
       end;
  mutarea_ta:=false;

  if a[Nr_Diferite] < nr then
  begin
    writeln('>>> Extragi mai multe monede decat exista in cea mai mica gramada!!!');
    writeln(fo,1);
    close(fo);
    halt;
  end;

  ExecutaMutare(nr);

  if final
  then Evaluare;
end;

procedure MutareaTa(var nr : longint);
begin
  if final
  then begin
         writeln('>>> Nu mai sunt piese pe tabla si nu mai poti face mutari !!!');
         writeln(fo,1);
         close(fo);
         halt;
       end;
  if mutarea_ta
  then begin
         writeln('>>> Nu este randul calculatorului la mutare !');
         writeln(fo,1);
         close(fo);
         halt;
       end;

  mutarea_ta := true;

  if a[Nr_Diferite] = 1
  then begin
         nr := 1;
         ExecutaMutare(1);
       end
  else if c[Nr_Diferite]
       then begin
              nr := a[Nr_Diferite];
              ExecutaMutare(a[Nr_Diferite]);
            end
       else begin
              nr := a[Nr_Diferite]-1;
              ExecutaMutare(a[Nr_Diferite]-1);
            end;

  if final
  then begin
         writeln('>>> Te-am batut!');
         writeln(fo,1);
         close(fo);
         halt;
       end;
end;

begin
  textcolor(lightgray);
  textbackground(black);
{  regs.ah := $34;
  msdos(regs);
  ok_ := ptr(regs.es, regs.bx);
  getintvec(8, p);
  old8h := intproc(p);
  int08seg := memw[0:8*4+2];
  int08ofs := memw[0:8*4];

  asm
   mov dx,int08seg
   mov cx,int08ofs
   mov ah,0fbh
   int 21h
  end;

  maxtimp := 2 + MM * 200 div 11;
  timp := 0;
  setintvec(8, @new8h);
}
  assign(f,'joc.in');
  reset(f);
  assign(fo,'joc.out');
  rewrite(fo);
  readln(f,n);
  for i := 1 to n do
    read(f,a[i]);
  close(f);

  Sort(1,n);
  Nr_Diferite := CalculeazaDiferente;
  Inv;
  CalculeazaStrategie;

  mutarea_ta := true;
end.