#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define sqr(x) ((x)*(x))

int n;
float len;
float x[101];
float y[101];
int na;
int at[500];



void citeste(void)
{
	FILE * fin;
	int i;

	if(!(fin=fopen("PENDULA.IN","r"))){
		fprintf(stderr,"No can open input file :(\n");
		exit(42);
	}
	fscanf(fin,"%f",&len);
	fscanf(fin,"%d",&n);
	for(i=1;i<=n;i++)
		fscanf(fin,"%f%f",x+i,y+i);
	fclose(fin);
}


void prel(void)
{
	int i,j;
	int curr=1,last=0;
	int ren[101];
	float dp[101];
	float um,u,tmp;

	x[0]=x[1]+1.0;
	y[0]=y[1];
	na=0;
	for(i=1;i<=n;i++)
		ren[i]=i;
	dp[0]=1.0;
	while(1){
		/*printf("na=%d\nl =%f\n",na,len);*/
		for(i=1;i<=n;i++)
			dp[i]=sqr(x[curr]-x[i])+sqr(y[curr]-y[i]);
		j=1;
		for(i=1;i<=n;i++)
			if(dp[i]<(len*len)){
				if(i==last)last=j;
				if(i==curr)curr=j;
				dp[j]=dp[i];
				x[j]=x[i];
				y[j]=y[i];
				ren[j++]=ren[i];
			}
		n=j-1;
		if(n<2)
			break;
		j=curr;
		um=120.0;
		for(i=1;i<=n;i++)
			if((i!=curr)&&
			(((y[i]   +y[curr])*(x[curr]-x[i])+
			  (y[curr]+y[last])*(x[last]-x[curr])+
			  (y[last]+y[i]   )*(x[i]   -x[last]))>=0)
			){
				tmp=sqr(x[i]-x[last])+sqr(y[i]-y[last]);
				u=(dp[last]+dp[i]-tmp)/sqrt(dp[i]*dp[last]);
				if(u<um){
					um=u;
					j=i;
				}else
				   if(
				       ((u-um)<0.0001)&&
				       ((um-u)<0.0001)

				   ){
					if(dp[j]<dp[i])
						j=i;
				}
			}
		if(j!=curr){
			at[na++]=ren[j];
			len -= sqrt(dp[j]);
			last=curr;
			curr=j;
			continue;
		}else{
			um=120.0;
			for(i=1;i<=n;i++)
				if((i!=curr)&&
				(((y[i]   +y[curr])*(x[curr]-x[i])+
				  (y[curr]+y[last])*(x[last]-x[curr])+
				  (y[last]+y[i]   )*(x[i]   -x[last]))<0)
				){
					tmp=sqr(x[i]-x[last])+sqr(y[i]-y[last]);
					u=(dp[last]+dp[i]-tmp)/sqrt(dp[i]*dp[last]);
					if(u<um){
						um=u;
						j=i;
					}else if(abs(u-um)<1e-10){
						if(dp[j]<dp[i])
							j=i;
					}
				}


		}
		if(j==curr)break;
		at[na++]=ren[j];
		len -= sqrt(dp[j]);
		last=curr;
		curr=j;
	}
}


void afis(void)
{
	int i;
	FILE *fout;

	if(!(fout=fopen("PENDULA.OUT","w"))){
		fprintf(stderr,"No can open output file :(\n");
		exit(42);
	}
	for(i=0;i<na;i++)
		fprintf(fout,"%d\n",at[i]);
	fclose(fout);
}





int main(void)
{
	citeste();
	prel();
	afis();

	return 0;
}