program Numarare;
const   NMax = 20;
        PMax=200;
        intrare='pact.in';
        iesire='pact.out';
type    Numar=String[200];
        Indice = 0 .. NMax;
        PLinie=^Linie;
        Linie=array[Indice] of Numar;
        Vector = array[0..PMax] of Numar;
        Puteri=^Vector;
var     n: byte;
        doi:Puteri;
        cn: array[Indice] of Numar;
        comb:array[Indice] of PLinie;

function Cifra(c:char):byte;
begin
     Cifra := ord(c)-48;
end;

function Inm(a:Numar; c: char):Numar;
var i, t, cif:byte;
    p:Numar;
begin
p:=''; t:=0;
for i:=length(a) downto 1 do
        begin
        cif :=  (t+cifra(c)*cifra(a[i])) mod 10;
        t := (t+cifra(c)*cifra(a[i])) div 10;
        p:=chr(cif+48)+p;
        end;
if t>0 then  p:=chr(t+48)+p;
Inm:=p;
end;

procedure doila;
var i: byte;
begin
     getmem(doi, (PMax+1)*181);
     doi^[0]:='1';
     for i := 1 to n*(n-1) div 2 do
         doi^[i]:=Inm(doi^[i-1], '2');
end;

function Adunare (a, b: Numar): Numar;
var t, cif, i: byte;
    s:Numar;
begin
while length(a)<length(b) do a:='0'+a;
while length(a)>length(b) do b:='0'+b;
t:=0;  s:='';
for i := length(a) downto 1 do
    begin
    cif:= (t+ cifra(a[i])+cifra(b[i])) mod 10;
    t:= (t+ cifra(a[i])+cifra(b[i])) div 10;
    s:=chr(cif+48)+s;
    end;
if t>0 then s:=chr(t+48)+s;
Adunare:=s;
end;

procedure Combinari;
var i, j: byte;
begin
getmem(Comb[0],3*Sizeof(Numar)); Comb[0]^[0]:='1'; Comb[0]^[1]:='0'; Comb[0]^[2]:='0';
getmem(Comb[1], 3*Sizeof(Numar));Comb[1]^[0]:='1'; Comb[1]^[1]:='1'; Comb[1]^[2]:='0';
for i := 2 to n do
    begin
    getmem(Comb[i], (i+1)*Sizeof(Numar));
    Comb[i]^[0]:='1';
    Comb[i]^[i]:='1';
    for j := 1 to i-1 do
        Comb[i]^[j]:=Adunare(Comb[i-1]^[j], Comb[i-1]^[j-1]);
    end;
end;

function Produs(a, b:Numar):Numar;
var c, pp: Numar;
    i, k:byte;
begin
c:='';
for i := length(b) downto 1 do
    begin
    pp:=Inm(a, b[i]);
    for k := 1 to length(b)-i do pp:=pp+'0';
    c:=Adunare(c, pp);
    end;
Produs:=c;
end;

function Scadere (a,b:Numar):Numar;
var c:Numar;
    i:byte;
    t, cif:integer;
begin
t:=0; c:='';
while length(a)>length(b) do b:='0'+b;
for i:=length(a) downto 1 do
    begin
    if t+cifra(a[i])-cifra(b[i]) >= 0 then
       begin
       cif := t+cifra(a[i])-cifra(b[i]);
       t:=0;
       end
       else
       begin
       cif := 10+t+cifra(a[i])-cifra(b[i]);
       t:=-1;
       end;
    c:=chr(cif+48)+c;
    end;
while (c<>'')and (c[1]='0') do delete(c,1,1);
if c='' then c:='0';
Scadere:=c;
end;

function Impartire(a:Numar; c:byte):Numar;
var r:Numar;
    i, t, cif, inceput:byte;
begin
if (c<=cifra(a[1])) then begin t:=0; inceput:=1; end
        else begin t:=cifra(a[1]); inceput :=2; end;
r:='';
for i:=inceput to length(a) do
    begin
    cif := (cifra(a[i])+t*10) div c;
    t:=  (cifra(a[i])+t*10) mod c;
    r:=r+chr(cif+48);
    end;
Impartire:=r;
end;

procedure Calcul;
var i, k, ind: byte;
    cod:integer;
    s, P, sirk, ss:Numar;
begin
cn[1]:='1'; cn[2]:='1';
for i := 3 to n do
    begin
    s:='0';
    for k := 1 to i-1 do
        begin
        val(comb[i-k]^[2], ind, cod);
        str(k, sirk);
        p:=Produs(Produs(cn[k], sirk), Produs(doi^[ind], Comb[i]^[k]));
        s:=Adunare(s, p);
        end;
    val(comb[i]^[2], ind, cod);
    ss:=Impartire(s,i);
    cn[i]:=Scadere (doi^[ind], ss);
    end;
end;

procedure Citire;
var f:text;
begin
     assign (f, intrare); reset(f);
     readln (f, n);
     close(f);
end;

procedure Afisare;
var f:text;
begin
     assign (f, iesire); rewrite(f);
     writeln (f, cn[n]);
     close(f);
end;

begin
     Citire;
     Doila;
     Combinari;
     Calcul;
     Afisare;
end.
